<?php
/*
Plugin Name: Bloglines Blogroll
Plugin URI: http://www.digitalramble.com/bloglinesblogroll-wordpress-plugin/
Description: Uses your bloglines account to create a blogroll in your sidebar.
Author: Cindy Moore
Author: Chris Jones
Author URI: http://digitalramble.com
Version: 1.2
Disclaimer: Use at your own risk. No warranty expressed or implied is provided.
*/

/*
	Note: for this to work,  you must have a Bloglines account 
	(or else be interested in displaying a public account you like), 
	which is open to sharing, and has some public subscriptions.  
	Read up at bloglines if you're not sure what I'm 
	talking about: http://www.bloglines.com/help/share

	You  must pass in a title and your blogline username, and you 
	can optionally also pass in a folder and a target.

	More information on setup is available here:
	http://www.digitalramble.com/bloglinesblogroll-wordpress-plugin/

	Note that this uses CURL; if you do not have this, there is 
	an alternative call provided in the comments below.  But CURL is 
	safer; use it if you have it.
	
*/

add_action('plugins_loaded', 'BloglinesBlogroll_init');

function BloglinesBlogroll_init() {
    if (!function_exists('register_sidebar_widget')) {
        return;
    }

    register_sidebar_widget('Bloglines Blogroll', 'widget_BloglinesBlogroll');
    register_widget_control('Bloglines Blogroll', 'BloglinesBlogroll_menu');
}

function widget_BloglinesBlogroll($args) {
  extract($args);
?>
    <?php echo $before_widget; ?>
      <?php echo $before_title . 'Bloglines Blogroll' . $after_title; ?>
      <?php printBloglinesBlogroll(); ?>
    <?php echo $after_widget; ?>
<?php
}

function BloglinesBlogroll_menu() {
    if (isset($_POST['BloglinesBlogroll_title'])) {
        update_option('BloglinesBlogroll_title', $_POST['BloglinesBlogroll_title']);
    }

    $title = get_option('BloglinesBlogroll_title');
?>
    <p style="text-align:left"><label for="BloglinesBlogroll_title">Title: <input style="width:200px;" id="BloglinesBlogroll_title" name="BloglinesBlogroll_title" type="text" value="<?php echo $title; ?>" /></label></p>
<?php
    if (isset($_POST['BloglinesBlogroll_id'])) {
        update_option('BloglinesBlogroll_id', $_POST['BloglinesBlogroll_id']);
    }

    $id = get_option('BloglinesBlogroll_id');
?>
    <p style="text-align:left"><label for="BloglinesBlogroll_id">ID: <input style="width:200px;" id="BloglinesBlogroll_id" name="BloglinesBlogroll_id" type="text" value="<?php echo $id; ?>" /></label></p>
<?php
    if (isset($_POST['BloglinesBlogroll_folder'])) {
        update_option('BloglinesBlogroll_folder', $_POST['BloglinesBlogroll_folder']);
    }

    $folder = get_option('BloglinesBlogroll_folder');
?>
    <p style="text-align:left"><label for="BloglinesBlogroll_folder">Folder: <input style="width:200px;" id="BloglinesBlogroll_folder" name="BloglinesBlogroll_folder" type="text" value="<?php echo $folder; ?>" /></label></p>
<?php
    if (isset($_POST['BloglinesBlogroll_target'])) {
        update_option('BloglinesBlogroll_target', $_POST['BloglinesBlogroll_target']);
    }

    $target = get_option('BloglinesBlogroll_target');
?>
    <p style="text-align:left"><label for="BloglinesBlogroll_target">Target: <input style="width:200px;" id="BloglinesBlogroll_target" name="BloglinesBlogroll_target" type="text" value="<?php echo $target; ?>" /></label></p>
<?php

}

function printBloglinesBlogroll()
{
        $title = get_option('BloglinesBlogroll_title'); 
	$id = get_option('BloglinesBlogroll_id');
	$folder = get_option('BloglinesBlogroll_folder');
	$target = get_option('BloglinesBlogroll_target');
	
        $blprefix = 'http://rpc.bloglines.com/blogroll?html=1&id=';
	$blurl = $blprefix.$id;
	if (strlen($folder)>0)
	{
	  $blurl .= '&folder='.$folder;
	}
	if (strlen($target)>0)
	{
	  $blurl .= '&target='.$target;
	}


	$output = '';
	
	$output .= "<ul>\n";
	
	// safely download contents of external url using CURL
	// if no curl support, just replace the next nine lines with this one
	// $lines = file('http://example.com/');
	$ch = curl_init();
	$timeout = 5; // set to zero for no timeout
	curl_setopt ($ch, CURLOPT_URL, $blurl);
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
	$file_contents = curl_exec($ch);
	curl_close($ch);
	// end CURL file() substitute

	list($blogroll, $trash) = split('\<a href\=\"http\:\/\/www.bloglines.com\" style=\"', $file_contents);
	$folders = split('\<p \/\>\<div class\=\"blogrollfolder\"\>', $blogroll);
	$idx = 0;
	$fidx = 0;
	foreach ($folders as $folder) {
		if ($idx > 0) {
			$folder_content = split('\<\/div\>', $folder);
			foreach ($folder_content as $content) {
				if ($fidx == 0) {
					$output .= "</ul><u><b>$content</b></u><ul>";
				} else {
					$items = split('\<div class=\"blogrollitem\"\>', $content);
					foreach ($items as $item) {
						if (strlen(trim($item)) > 0) {
							$output .= '<li>' . $item . '</li>';
						}
					}
				}
				$fidx++;
			}
		}
		
		$idx++;
		$fidx = 0;
	}

	$output .= "</ul>\n";
	echo $output;
	return;
}

?>
